/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 8268:
/***/ (function(module) {

module.exports = require("@zpc_npm/vue-iclient-common/_utils/gis-utils");

/***/ }),

/***/ 2594:
/***/ (function(module) {

module.exports = require("@zpc_npm/vue-iclient-common/_utils/util");

/***/ }),

/***/ 8945:
/***/ (function(module) {

module.exports = require("@zpc_npm/vue-iclient-common/init.js");

/***/ }),

/***/ 637:
/***/ (function(module) {

module.exports = require("vue");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	!function() {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = function(module) {
/******/ 			var getter = module && module.__esModule ?
/******/ 				function() { return module['default']; } :
/******/ 				function() { return module; };
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
!function() {
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "StatusBarViewModel": function() { return /* reexport */ StatusBarViewModel; },
  "default": function() { return /* reexport */ StatusBar; }
});

// EXTERNAL MODULE: external {"root":"Vue","commonjs":"vue","commonjs2":"vue","amd":"vue"}
var external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_ = __webpack_require__(637);
// EXTERNAL MODULE: external "@zpc_npm/vue-iclient-common/_utils/util"
var util_ = __webpack_require__(2594);
// EXTERNAL MODULE: external "@zpc_npm/vue-iclient-common/_utils/gis-utils"
var gis_utils_ = __webpack_require__(8268);
;// CONCATENATED MODULE: ./src/leaflet/statusbar/StatusBarViewModel.js
/**
 * Author: ZL
 * Date: 2022.8.4
 * Description: 状态栏组件的逻辑类。
 */


class StatusBarViewModel extends window.L.Evented {
  /**
   * @param {string} mapTarget 绑定地图的div的id
   * @param {string} position 组件位置
   * @event setLevel 监听级别的事件
   * @event setXY 监听坐标的事件
   */
  constructor(mapTarget, position) {
    super();
    /**
     * 操作地图对象
     * @type {MapViewViewModel}
     * @private
     */

    this._webMap = null;
    /**
     * 外部参数
     * @type {{position: (string), mapTarget: string}}
     * @private
     */

    this._props = {
      mapTarget,
      position
    }; //事件绑定this

    this._onMousemove = this._onMousemove.bind(this);
    this._onZoomend = this._onZoomend.bind(this);

    this._registerEvents();
  }
  /**
   * 注册事件
   * @private
   */


  _registerEvents() {
    const self = this;
    gis_utils_.utils.getWebMap(this._mapTarget, webmap => {
      self._webMap = webmap;

      if (this._webMap.map) {
        self._setDefaultData();
      }
    });
  }
  /**
   * 绑定地图移动、缩放事件，获取坐标、比例尺
   * @private
   */


  _setDefaultData() {
    // 鼠标移动事件
    this._webMap.map.on("mousemove", this._onMousemove); // 鼠标缩放事件


    this._webMap.map.on("zoomend", this._onZoomend);

    let center = this._webMap.map.getCenter();

    this._setXY(center);

    this._setLevel();
  }
  /**
   * 地图鼠标移动函数
   * @param e
   * @private
   */


  _onMousemove(e) {
    this._setXY(e.latlng);
  }
  /**
   * 地图级别变化函数
   * @param e
   * @private
   */


  _onZoomend(e) {
    this._setLevel();
  }
  /**
   * 设置坐标
   * @param {L.latlng} point
   * @fires event:setXY
   * @private
   */


  _setXY(point) {
    let latFixed, lngFixed, lngName, latName;
    let epsg = this._webMap.webMapInfo.spatialReference.epsg; // 经纬度使用度分秒格式，平面坐标使用保留两位的数字

    if (!(epsg === 4490 || epsg === 4326)) {
      let firstProjection = new proj4.Proj("EPSG:4326");
      let secondProjection = new proj4.Proj("EPSG:" + epsg);
      let result = proj4.transform(firstProjection, secondProjection, [point.lng, point.lat]);
      latFixed = result.y.toFixed(2);
      lngFixed = result.x.toFixed(2);
      lngName = "经度：";
      latName = "纬度：";
    } else {
      latFixed = (0,util_.convertXY)(point.lat);
      lngFixed = (0,util_.convertXY)(point.lng);
      lngName = "X：";
      latName = "Y：";
    }

    this.fire("setXY", {
      lng: lngFixed,
      lat: latFixed,
      lngName,
      latName
    });
  }
  /**
   * 设置级别
   * @fires event:setLevel
   * @private
   */


  _setLevel() {
    let value = "";

    if (this._props.position && this._props.position === "bottomCenter") {
      value += "丨";
    }

    value += "级别：" + this._webMap.map.getZoom();
    this.fire("setLevel", {
      level: value
    });
  }
  /**
   * 销毁
   */


  destroy() {
    // 删除所有事件监听
    this.off();

    this._webMap.map.off("mousemove", this._onMousemove);

    this._webMap.map.off("zoomend", this._onZoomend);
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/leaflet/statusbar/StatusBar.vue?vue&type=script&setup=true&lang=js

const _hoisted_1 = {
  class: "status-bar"
};
const _hoisted_2 = {
  class: "panel-item"
};
const _hoisted_3 = {
  class: "textPanel"
};
const _hoisted_4 = {
  class: "jd"
};
const _hoisted_5 = {
  class: "panelItem"
};
const _hoisted_6 = {
  class: "wd"
};


const __default__ = {
  name: "Kq2dStatusBar"
};
/* harmony default export */ var StatusBarvue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(__default__, {
  props: {
    // 每个地图相关组件的必须参数 非必传 指定组件绑定的map对象的div的id
    mapTarget: String,
    // bottomCenter | bottomLeft | bottomRight
    position: {
      type: String,
      default: "bottomLeft"
    }
  },

  setup(__props) {
    const props = __props;
    let viewModel = null;
    let lngText = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.ref)("");
    let latText = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.ref)("");
    let lng = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.ref)("");
    let lat = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.ref)("");
    let level = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.ref)("");
    let direction = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.ref)("vertical");
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.onMounted)(() => {
      viewModel = new StatusBarViewModel(props.mapTarget, props.position); // 逻辑类监听数据设置事件

      viewModel.on("setXY", _data => {
        lng.value = _data.lng;
        lat.value = _data.lat;
        lngText.value = _data.lngName;
        latText.value = _data.latName;
      });
      viewModel.on("setLevel", _data => {
        level.value = _data.level;
      });
      setPosition();
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.onBeforeUnmount)(() => {
      viewModel.destroy();
      viewModel = null;
    });
    /**
     * 组件位置设置
     */

    function setPosition() {
      // position的值只有居中时“bottom-center”，才是横排
      if (props.position && props.position === "bottomCenter") {
        direction.value = "horizontal";
        document.querySelector(".status-bar").style.textAlign = "center";
        document.querySelector(".status-bar").style.width = "100%";
        document.querySelector(".status-bar").style.right = "unset";
      } else if (props.position && props.position === "bottomRight") {
        document.querySelector(".status-bar").style.left = "unset";
        document.querySelector(".status-bar").style.right = "20px";
        document.querySelector(".status-bar").style.textAlign = "unset";
      } else if (props.position && props.position === "bottomLeft") {
        document.querySelector(".status-bar").style.left = "20px";
        document.querySelector(".status-bar").style.right = "unset";
        document.querySelector(".status-bar").style.textAlign = "unset";
      }
    }

    return (_ctx, _cache) => {
      const _component_kq_space = (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.resolveComponent)("kq-space");

      return (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.openBlock)(), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.createElementBlock)("div", _hoisted_1, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.createVNode)(_component_kq_space, {
        direction: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.unref)(direction),
        alignment: "start",
        size: 4
      }, {
        default: (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.withCtx)(() => [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.createElementVNode)("div", _hoisted_2, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.createElementVNode)("span", _hoisted_3, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.unref)(lngText)), 1
        /* TEXT */
        ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.createElementVNode)("span", _hoisted_4, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.unref)(lng)), 1
        /* TEXT */
        )]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.createElementVNode)("div", _hoisted_5, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.createElementVNode)("span", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.unref)(latText)), 1
        /* TEXT */
        ), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.createElementVNode)("span", _hoisted_6, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.unref)(lat)), 1
        /* TEXT */
        )]), (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.createElementVNode)("div", null, [(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.createElementVNode)("span", null, (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.toDisplayString)((0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.unref)(level)), 1
        /* TEXT */
        )])]),
        _: 1
        /* STABLE */

      }, 8
      /* PROPS */
      , ["direction"])]);
    };
  }

}));
;// CONCATENATED MODULE: ./src/leaflet/statusbar/StatusBar.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/leaflet/statusbar/StatusBar.vue



const __exports__ = StatusBarvue_type_script_setup_true_lang_js;

/* harmony default export */ var StatusBar = (__exports__);
// EXTERNAL MODULE: external "@zpc_npm/vue-iclient-common/init.js"
var init_js_ = __webpack_require__(8945);
var init_js_default = /*#__PURE__*/__webpack_require__.n(init_js_);
;// CONCATENATED MODULE: ./src/leaflet/statusbar/index.js




StatusBar.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(StatusBar.name, StatusBar);
};


}();
module.exports = __webpack_exports__;
/******/ })()
;